<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Input Library</h1>

		<p>The input library provides two purposes which are the following.</p>

		<ol>
			<li>It preprocesses global input data for security.</li>
			<li>It provides methods for retrieving input data.</li>
		</ol>

		<p><i>Note</i>: this library is loaded automatically by CarbonPHP.</p>
	</div>

	<div class="content">
		<h1>Data Sanitising</h1>

		<p>The security filtering of CarbonPHP is called automatically when a controller is initialised.  This filter
		does the following.</p>

		<ul>
			<li>Unsets the global <b>$_GET</b> array, this is because CarbonPHP doesn't use query strings.</li>
			<li>Unsets any global variables in the event that <b>register_globals</b> is enabled.</li>
			<li>Sanitised the <b>$_POST</b> and <b>$_COOKIE</b> arrays, only allowing alpha-numeric characters.</li>
			<li>Provides a method is filter any cross site scripting attempts.</li>
			<li>Standardises any newline characters to the character <b>\n</b></li>
		</ul>
	</div>

	<div class="content">
		<h1>Cross Site Scripting Filtering</h1>

		<p>CarbonPHP comes with a cross site scripting filter that can filter any attempts of cross site scripting.
		The cross site scripting filter looks for common techniques used for cross site scripting. <i>Note</i>: it
		doesn't escape all HTML entities, only those involved in cross site scripting.</p>

		<p><i>Note</i>: this method should only be used for data submission.  It's processing overhead is fairly high
		to use it on runtime processing.</p>

		<p>To use the cross site scripting method you can call it like the following example.</p>

		<div class="example">
			$data = $this->input->xss_clean($data);
		</div>

		<p>If you wish to run the filter automatically every time CarbonPHP encounters <b>$_POST</b> or
		<b>$_COOKIE</b> data.  You enable it by editing the option in the <b>application/config/config.php</b>
		file.</p>

		<div class="example">
			$config['use_xss_filtering'] = true;
		</div>
	</div>

	<div class="content">
		<h1>Using POST, COOKIE, and SERVER Data</h1>

		<p>CarbonPHP comes with some methods that allow you to retrieve POST, COOKIE, and SERVER data.  The main
		advantage of using these methods are rather than retrieving an item directly, the methods will check whether
		an item is set, and return <b>false</b> if they're not set.</p>

		<div class="example">
			$somevar = $this->input->post('somevar');
		</div>

		<p>There are three methods for retrieving POST, COOKIE, and SERVER data.</p>

		<ul>
			<li>$this->input->post()</li>
			<li>$this->input->cookie()</li>
			<li>$this->input->server()</li>
		</ul>
	</div>

	<div class="content">
		<h1>$this->input->post()</h1>
		
		<p>The first parameter will contain the name of the POST item you wish to retrieve.</p>
		
		<div class="example">
			$this->input->post('email');
		</div>

		<p>The method returns <b>false</b> if the item does not exist.  There is an optional second
		parameter that lets you run the data through the cross site scripting filter.  It is enabled
		by setting the second parameter to <b>true</b>.</p>

		<div class="example">
			$this->input->post('email', true);s
		</div>
	</div>

	<div class="content">
		<h1>$this->input->cookie()</h1>
		
		<p>This method is identical to the post method, except it retrieves cookie data.</p>
		
		<div class="example">
			$this->input->cookie('username', true);
		</div>
	</div>

	<div class="content">
		<h1>$this->input->server()</h1>
		
		<p>This method is identical to the above methods, except it retrieves server data.</p>
		
		<div class="example">
			$this->input->server('some_data');
		</div>
	</div>

	<div class="content">
		<h1>$this->input->ip_address()</h1>
		
		<p>This method returns the IP address for the current user.  If the IP address is not valid
		the method will return '0.0.0.0'.</p>
		
		<div class="example">
			echo $this->input->ip_address();
		</div>
	</div>

	<div class="content">
		<h1>$this->input->valid_ip()</h1>
		
		<p>This method takes an IP address and returns <b>true</b> or <b>false</b> if it is valid or not.</p>
		
		<div class="example">
			if (!$this->input->valid_ip($ip))<br />
			{<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'Not valid';<br />
			}<br />
			else<br />
			{<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'Valid';<br />
			}
		</div>
	</div>

	<div class="content">
		<h1>$this->input->user_agent()</h1>
		
		<p>The method returns the user agent (web browser) being used by the current user.  Returns <b>false</b>
		if the information is unavailable.</p>
		
		<div class="example">
			echo $this->input->user_agent();
		</div>
	</div>
</body>

</html>
